( 3iBeats_cookbook.fs - AE - 2021-05-24---Mon---08:09 )

\ include 3iForth, 3iShift.fs
\ help-shiftin  (init twice)
\ .b
\ >b8

: nseq nseq-msb ;

\ 2021-05-24---Mon---08:32
\ IDEA: create a beats entry module --- OLED screen, simple menu -- bar 1 through bar 8, clear, enter 1 (strike) or 0 (rest) buttons
\   scroll through the 4 notes in the bar in 1 e and a notation...
\   enter and then loop
\ slow or fast metronome with a potentiometer
\ complements the hardware beats selector with DIP switch that is likely to be quite challenging to set/unset
\ Can an ATTINY monitor 16-key keypad effectively?

\ 8x 16th notes = 4x quarter notes = 1 bar


\ 1 BAR BEATS
: beatA1 255 1 nseq ; \ constant 16th notes (8x)
: beatA2 170 1 nseq ; \ constant 8th notes  (4x)
: beatA3 136 1 nseq ; \ constant quarter notes (2x)
: beatA4 128 1 nseq ; \ constant half notes (1x)


: beatB 254 1 nseq ;  \ 7/8 on 1
: beatB 253 1 nseq ;  \ 7/8 on 2?
: beatB 251 1 nseq ;  \ 7/8 on 3?
: beatB 247 1 nseq ;  \ 7/8 on 4?
: beatB 239 1 nseq ;  \ 7/8 on 5?
: beatB 223 1 nseq ;  \ 7/8 on 6?

: beatC 250 1 nseq ;

: beatD 246 1 nseq ;

: beatE 245 1 nseq ; \ rapper beat
: beatE 236 1 nseq ; 

: beatF 244 1 nseq ;
: beatF 242 1 nseq ;
: beatF 237 1 nseq ;

: beatG 238 1 nseq ; \ regular 3's
: beatG 234 1 nseq ; \ irregular 3's
: beatG 232 1 nseq ; \ syncopated 3's
: beatG 224 1 nseq ; \ isolated 3's
: beatG 225 1 nseq ; \ isolated 4's

: beatH 218 1 nseq ; \ samba?


\ INDIAN beats

: regular1 136 136 2 nseq ;
: regular2 170 170 2 nseq ;
: tan-tada 139 139 2 nseq ;
: da-dum  132 136 2 nseq ;  \ like garba?
: beat1  149 36 2 nseq ;
: beat2  240 1 nseq ;
: 12talala 171 1 nseq ;
: rasra1 ( -- ) 125 beatdur! 156 1 nseq 1 ndrop ;  \ 2 beat rests give this a slightly off-beat flavor
: rasra2 ( -- ) 125 beatdur! 184 1 nseq 1 ndrop ;
: rasra3 ( -- ) setpot key drop ( 180 beatdur! ) 4 init-percustones  186 235 174 3 nseq 3 ndrop ; \ 1 beat rests provide right emphasis, need 6 notes to cover beat (6/8 time)
\ ginan garbi: https://www.jollygul.com/ginans-garbi/
\ 9: pir nachine kanthe ginanre ma   Scale: Indian Todi raga  Lyrics: http://www.ismaili.net/heritage/node/24298
\ 1: evi garbi sampurana
\ 7: gur vadea dasmi rat 


\ ===================================================
\ V2 - 2021-06-01---Tue---02:04  added: beat sequence with tones -- for two-tone drum for e.g. garbi -- bass and snare or clap & snap
